﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ComponentModel;
using System.Collections.ObjectModel;

namespace WpfApplication1
{
    public class MyData : INotifyPropertyChanged
    {
        private string m_text;
        public string Text
        {
            get { return this.m_text; }
            set { this.m_text = value; this.OnPropertyChanged("Text"); }
        }

        public ObservableCollection<MyData> children { get; set; }

        public event PropertyChangedEventHandler PropertyChanged;

        private void OnPropertyChanged(string prop)
        {
            if (this.PropertyChanged != null)
                this.PropertyChanged(this, new PropertyChangedEventArgs(prop));
        }

        public MyData()
        {
            children = new ObservableCollection<MyData>();
        }
    }

    public class MyCollection : ObservableCollection<MyData>
    {
        public MyCollection()
        {
            int level1Count = 3;
            int level2Count = 2;
            int level3Count = 3;
            int level4Count = 1;
            Random rand = new Random();

            for (int i = 0; i < level1Count; i++)
            {
                MyData data = new MyData();
                data.Text = "Data" + rand.Next().ToString();
                this.Add(data);

                // Add some children.
                for (int j = 0; j < level2Count; j++)
                {
                    MyData child = new MyData();
                    child.Text = "Data" + rand.Next().ToString();
                    data.children.Add(child);

                    // Add some children.
                    for (int k = 0; k < level3Count; k++)
                    {
                        MyData secondChild = new MyData();
                        secondChild.Text = "Data" + rand.Next().ToString();
                        child.children.Add(secondChild);

                        // Add some children.
                        for (int l = 0; l < level4Count; l++)
                        {
                            MyData thirdChild = new MyData();
                            thirdChild.Text = "Data" + rand.Next().ToString();
                            secondChild.children.Add(thirdChild);
                        }
                    }
                }
            }
        }
    }
}
